import ij.IJ;
import ij.Prefs;
import ij.gui.GenericDialog;
import ij.plugin.PlugIn;
import imagescience.utilities.Messenger;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Panel;

public class TJ_Options implements PlugIn {

    final static String VERSION = "2.6.0";

    static boolean asksave = Prefs.get("tj.asksave",false);
    static boolean debug = Prefs.get("tj.debug",false);

    public void run(String arg) {

	msg.debug(debug);
	msg.debug("TransformJ "+TJ_Options.VERSION+": Options");

	if (IJ.versionLessThan("1.35i")) return;

	GenericDialog gd = new GenericDialog("TransformJ: Options");
	gd.addCheckbox(" Save result images before closing    ",asksave);
	gd.addCheckbox(" Debug messenging    ",debug);
	gd.addPanel(new Panel(),GridBagConstraints.EAST,new Insets(0,0,0,0));
	gd.showDialog();

	if (gd.wasCanceled()) return;

	asksave = gd.getNextBoolean();
	debug = gd.getNextBoolean();

	Prefs.set("tj.asksave",asksave);
	Prefs.set("tj.debug",debug);

	msg.debug(debug);

	if (asksave) msg.debug("Asking to save result images before closing");
	else msg.debug("Closing result images without asking to save");

	if (debug) msg.debug("Showing debug messages");
	else msg.debug("Hiding debug messages");
    }

    private final Messenger msg = new Messenger();

}
